/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File name:       mdl_expression.ipp                                       */
/* Description:     expression module                                        */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_EXPRESSION_IPP_
#define MDL_EXPRESSION_IPP_

#include "mdl/expression/build/mdl_expression_build.ipp"
#include "mdl/expression/direction/mdl_expression_direction.ipp"
#include "mdl/expression/iterator/mdl_expression_iterator.ipp"
#include "mdl/expression/node/mdl_expression_node.ipp"
#include "mdl/expression/parse/mdl_expression_parse.ipp"
#include "mdl/expression/simify/mdl_expression_simify.ipp"
#include "mdl/expression/unify/mdl_expression_unify.ipp"

#include "mdl/expression/mdl_expression_Array.ipp"
#include "mdl/expression/mdl_expression_Branching.ipp"
#include "mdl/expression/mdl_expression_Bush.ipp"
#include "mdl/expression/mdl_expression_Forest.ipp"
#include "mdl/expression/mdl_expression_Linear.ipp"
#include "mdl/expression/mdl_expression_List.ipp"
#include "mdl/expression/mdl_expression_Mode.ipp"
#include "mdl/expression/mdl_expression_Substitution.ipp"
#include "mdl/expression/mdl_expression_Substiunit.ipp"
#include "mdl/expression/mdl_expression_Symbol.ipp"
#include "mdl/expression/mdl_expression_Term.ipp"
#include "mdl/expression/mdl_expression_Tree.ipp"

#include "mdl/expression/mdl_expression.tpp"

#endif /*MDL_EXPRESSION_IPP_*/
