/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File name:       mdl_expression_unify_exp_Result.ipp                      */
/* Description:     unification result class                                 */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_EXPRESSION_UNIFY_EXP_RESULT_IPP_
#define MDL_EXPRESSION_UNIFY_EXP_RESULT_IPP_

namespace mdl {
namespace expression {
namespace unify {
namespace exp {

	/****************************
	 *		Public members
	 ****************************/

#ifndef DEBUG
	template<class U, class A>
	inline
	Result<U, A> :: Result () :
	List_() {
	}
	template<class U, class A>
	inline
	Result<U, A> :: Result (const Result& result) :
	List_(result) {
	}
	template<class U, class A>
	inline
	Result<U, A> :: Result (const Unit_ unit) :
	List_() {
		List_ :: addLast (unit);
	}
#endif /*RELEASE*/

#ifdef DEBUG
	template<class U, class A>
	inline
	Result<U, A> :: Result () :
	List_(),
	correct_ (true) {
	}
	template<class U, class A>
	inline
	Result<U, A> :: Result (const Result& result) :
	List_(result),
	correct_ (result.correct_) {
	}
	template<class U, class A>
	inline
	Result<U, A> :: Result (const Unit_ unit) :
	List_(),
	correct_ (true) {
		try {
			unit.verifyIntegrity();
		} catch (Error* error) {
			correct_ = false;
			//std :: cerr << error->message() << std :: endl;
			throw error;
		}
		List_ :: addLast (unit);
	}
#endif /*DEBUG*/

}
}
}
}

#endif /*MDL_EXPRESSION_UNIFY_EXP_RESULT_IPP_*/
