/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File name:       mdl_expression_unify_sub_Finaly.hpp                      */
/* Description:     final procedure of a substitution unification            */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_EXPRESSION_UNIFY_SUB_FINALY_HPP_
#define MDL_EXPRESSION_UNIFY_SUB_FINALY_HPP_

namespace mdl {
namespace expression {
namespace unify {
namespace sub {

template<class S>
class Finaly {
public :
	typedef S Substitution_;

	static void addPropEvidence
	(
		const index :: Arity arity,
		prover :: Evidence* evidenceSub,
		const prover :: Evidence* evidenceUp[]
	);
	static prover :: Evidence* supplySubEvidence
	(
		const value :: Integer boundary,
		const Substitution_* sb,
		const Substitution_* dl,
		const Substitution_* th,
		prover :: evidence :: Vector& proofs
	);
};

}
}
}
}

#endif /*MDL_EXPRESSION_UNIFY_SUB_FINALY_HPP_*/
