/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File name:       mdl_expression_unify_sub_prod_Unify.hpp                  */
/* Description:     scalar substitution unifier module                       */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_EXPRESSION_UNIFY_SUB_PROD_UNIFY_HPP_
#define MDL_EXPRESSION_UNIFY_SUB_PROD_UNIFY_HPP_

#include "mdl/expression/unify/sub/prod/mdl_expression_unify_sub_prod_Unifier.hpp"

namespace mdl {
namespace expression {
namespace unify {
namespace sub {
namespace prod {

template
<
	class E,
	int P = policy :: SYMMETRIC,
	int K = kind :: COMMON,
	class A = allocator :: Stack
>
class Unify : public Unifier<E, P, K, A> {
};

}
}
}
}
}

#endif /*MDL_EXPRESSION_UNIFY_SUB_PROD_UNIFY_HPP_*/
