/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File name:       mdl_expression_unify_sub_tree_Finalize.hpp               */
/* Description:     final procedure of a matrix unification                  */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_EXPRESSION_UNIFY_SUB_TREE_FINALIZE_HPP_
#define MDL_EXPRESSION_UNIFY_SUB_TREE_FINALIZE_HPP_

namespace mdl {
namespace expression {
namespace unify {
namespace sub {
namespace tree {

template<class U>
class Finalize {
public :
	typedef U Unit_;
	typedef
		typename Unit_ :: Proof_
		Proof_;
	typedef
		typename Unit_ :: Substitution_
		Substitution_;

	Finalize
	(
		const Substitution_*,
		prover :: evidence :: Vector&,
		const value :: Integer
	);

	void operator() (const Unit_&);

private :
	const Substitution_* createTheta (const Unit_&) const;

	const Substitution_* substitutionInt_;
	prover :: evidence :: Vector& proofs_;
	const value :: Integer boundary_;
};

}
}
}
}
}

#endif /*MDL_EXPRESSION_UNIFY_SUB_TREE_FINALIZE_HPP_*/
