/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File name:       mdl_expression_unify_sub_tree_Unify.hpp                  */
/* Description:     wrapper for the multy Unifier class                      */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_EXPRESSION_UNIFY_SUB_TREE_UNIFY_HPP_
#define MDL_EXPRESSION_UNIFY_SUB_TREE_UNIFY_HPP_

namespace mdl {
namespace expression {
namespace unify {
namespace sub {
namespace tree {

template
<
	class C,
	class P,
	class A = allocator :: Stack
>
class Unify : public Unifier<Unit<C, P, A> > {
public :
	typedef Unit<C, P, A> Unit_;
	typedef Unifier<Unit_> Unifier_;
	typedef
		typename Unit_ :: Substitution_
		Substitution_;

	Unify
	(
		const index :: Arity dimension,
		const Substitution_* subInt,
		prover :: evidence :: Vector& proofs,
		const value :: Integer boundary
	) :
	Unifier_ (dimension, subInt, proofs, boundary) {
	}
};

}
}
}
}
}

#endif /*MDL_EXPRESSION_UNIFY_SUB_TREE_UNIFY_HPP_*/
