/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_form_header_statement_Experience.cpp                 */
/* Description:     proposition usage experience                             */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_FORM_HEADER_STATEMENT_EXPERIENCE_CPP_
#define MDL_FORM_HEADER_STATEMENT_EXPERIENCE_CPP_

namespace mdl {
namespace form {
namespace header {
namespace statement {

	/****************************
	 *		Public members
	 ****************************/

	inline
	Experience :: Experience() :
	positiveNodes_ (),
	negativeNodes_ (),
	positiveCount_ (0),
	negativeCount_ (0) {
	}
	Experience :: ~ Experience() {
	}

	// prover :: Experience implementation
	void
	Experience :: addPositive (const mdl :: proof :: Step* const node)
	{
		positiveNodes_.addLast (node);
		++ positiveCount_;
	}
	void
	Experience :: addNegative (const mdl :: proof :: Step* const node)
	{
		if (positiveCount_ * Config :: getExperienceFactor() < negativeCount_) {
			return;
		}
		negativeNodes_.addLast (node);
		++ negativeCount_;
	}
	value :: Weight
	Experience :: evaluateFitness (const index :: Step index) const
	{
		return 0;
		/*const value :: Weight
			positiveWeight = evaluateAverage (premises, index, positiveCount_, positiveNodes_);
		const value :: Factor
			negativeWeight = evaluateAverage (premises, index, negativeCount_, negativeNodes_);
		const value :: Weight
			fitness =
			Config :: getPositiveFactor() * positiveWeight -
			Config :: getNegativeFactor() * negativeWeight;
		return fitness;*/
	}

	// object :: Object implementation
	void
	Experience :: commitSuicide() {
		delete this;
	}
	Size_t
	Experience :: getVolume() const
	{
		Size_t volume = 0;
		volume += positiveNodes_.getVolume();
		volume += negativeNodes_.getVolume();
		return volume;
	}
	Size_t
	Experience :: getSizeOf() const {
		return sizeof (Experience);
	}
	void
	Experience :: show (String& string) const {
	}

	/****************************
	 *		Private members
	 ****************************/

	value :: Weight
	Experience :: evaluateAverage
	(
		const index :: Step index,
		const value :: Integer count,
		const List_& nodeList
	) const
	{
		if (count == 0) {
			return 0;
		}
		value :: Factor sum = 0;
		/*const List_ :: Node_*
			listNode = nodeList.getFirst();
		while (listNode != NULL) {
			const mdl :: proof :: Step*
				step = listNode->getValue();
			const mdl :: Assertion*
				theorem = step->getScope()->getAssertion();
			sum += 0;
				evaluateSimilarity
				(
					premises,
					index,
					theorem->getPremises(),
					step->getIndex()
				);
			listNode = listNode->getNext();
		}*/
		const value :: Weight
			average = sum / count;
		return average;
	}
	value :: Weight
	Experience :: evaluateSimilarity
	(
		const index :: Step indexCurrent,
		const index :: Step indexExperience
	) const
	{
		return 0;
		/*typedef
			forest :: Premise :: Simify_<forest :: Premise> :: Similarity_
			Similarity;

		const Similarity
			formSimilarity; //=
			premisesExperience.getForm().simify
			(
				&premisesCurrent.getForm(),
				indexCurrent,
				indexExperience
			);
		const Similarity
			contentsSimilarity; // =
			premisesExperience.getContents().simify
			(
				&premisesCurrent.getContents(),
				indexCurrent,
				indexExperience
			);

		const value :: Weight formWeight =
			(formSimilarity.getDirect() + formSimilarity.getInverse()) /
			(premisesExperience.getForm().getSymbolVolume() + premisesCurrent.getForm().getSymbolVolume());

		const value :: Weight contentsWeight =
			(contentsSimilarity.getDirect() + contentsSimilarity.getInverse()) /
			(premisesExperience.getContents().getSymbolVolume() + premisesCurrent.getContents().getSymbolVolume());

		const value :: Weight similarity =
			Config :: getFormFactor() * formWeight +
			Config :: getContentsFactor() * contentsWeight;

		return similarity;*/
	}
}
}
}
}

#endif /*MDL_FORM_HEADER_STATEMENT_PROPOSITION_EXPERIENCE_CPP_*/
