/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_form_header_statement_Experience.hpp                 */
/* Description:     proposition usage experience                             */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_FORM_HEADER_STATEMENT_EXPERIENCE_HPP_
#define MDL_FORM_HEADER_STATEMENT_EXPERIENCE_HPP_

namespace mdl {
namespace form {
namespace header {
namespace statement {

class Experience :
	public prover :: Experience,
	public Scalar<Experience> {
public :
	Experience();
	virtual ~ Experience();

	// prover :: Experience interface
	virtual void addPositive (const mdl :: proof :: Step* const);
	virtual void addNegative (const mdl :: proof :: Step* const);
	virtual value :: Weight evaluateFitness (const index :: Step) const;

	// object :: Object interface
	virtual void commitSuicide();
	virtual Size_t getVolume() const;
	virtual Size_t getSizeOf() const;
	virtual void show (String&) const;

private :
	typedef
		list :: List
		<
			const mdl :: proof :: Step*,
			storage :: ByValue,
			allocator :: Heap
		>
		List_;

	value :: Weight evaluateAverage
	(
		const index :: Step,
		const value :: Integer,
		const List_&
	) const;
	value :: Weight evaluateSimilarity
	(
		const index :: Step,
		const index :: Step
	) const;

	List_ positiveNodes_;
	List_ negativeNodes_;
	value :: Integer positiveCount_;
	value :: Integer negativeCount_;
};

}
}
}
}

#endif /*MDL_FORM_HEADER_STATEMENT_EXPERIENCE_HPP_*/
