/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_form.hpp                                             */
/* Description:     module for all AST forms                                 */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_FORM_HPP_
#define MDL_FORM_HPP_

#include "mdl/form/mdl_form.dpp"

#include "mdl/form/block/mdl_form_block.hpp"
#include "mdl/form/header/mdl_form_header.hpp"
#include "mdl/form/proof/mdl_form_proof.hpp"

#include "mdl/form/mdl_form_Comments.hpp"
#include "mdl/form/mdl_form_Contents.hpp"
#include "mdl/form/mdl_form_Identifiable.hpp"
#include "mdl/form/mdl_form_Identificator.hpp"
#include "mdl/form/mdl_form_Import.hpp"
#include "mdl/form/mdl_form_Source.hpp"
#include "mdl/form/mdl_form_Theory.hpp"

#endif /*MDL_FORM_HPP_*/
