/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_form_Identificator.hpp                               */
/* Description:     identificator                                            */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_FORM_IDENTIFICATOR_HPP_
#define MDL_FORM_IDENTIFICATOR_HPP_

#include "mdl/interface/mdl_interface.hpp"

namespace mdl {
namespace form {

class Identificator :
	public mdl :: Identificator,
	public Scalar<Identificator> {
public :
	Identificator();
	Identificator (const mdl :: Identificator&);
	Identificator (const mdl :: Identificator* const);
	Identificator (const value :: Name);
	virtual ~ Identificator();

	// mdl :: Identificator interface
	virtual value :: Name getName() const;
	virtual const mdl :: Identificator* getNext() const;
	virtual void setNext (const mdl :: Identificator* const) const;

	// object :: Writable interface
	virtual void translate (String&) const;
	virtual void replicate (String&) const;

	// object :: Object interface
	virtual void commitSuicide();
	virtual Size_t getVolume() const;
	virtual Size_t getSizeOf() const;

private :
	const value :: Name name_;
	mutable const mdl :: Identificator* next_;
};

}
}

#endif /*MDL_FORM_IDENTIFICATOR_HPP_*/
