/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_form_proof_scope_Scope.hpp                           */
/* Description:     base scope class                                         */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_FORM_PROOF_SCOPE_SCOPE_HPP_
#define MDL_FORM_PROOF_SCOPE_SCOPE_HPP_

#include "mdl/interface/mdl_interface.hpp"

namespace mdl {
namespace form {
namespace proof {
namespace scope {

class Scope : public mdl :: proof :: Scope {
public :
	Scope (const mdl :: proof :: Scope* const);
	virtual ~ Scope();

	// proof :: Scope interface
	virtual const mdl :: Assertion* getAssertion () const = 0;
	virtual const mdl :: proof :: Claim* getClaim() const = 0;
	virtual const mdl :: proof :: Node* getHypothesis (const index :: Arity) const = 0;
	virtual const mdl :: proof :: Node* getProposition (const index :: Arity) const = 0;
	virtual const object :: Typing* getVariables() const = 0;
	virtual const mdl :: proof :: Notation* getNotation (const value :: Literal) const = 0;
	virtual const mdl :: proof :: Step* getStep (const index :: Step) const = 0;

	// object :: Object interface
	virtual void commitSuicide() = 0;
	virtual Size_t getVolume() const;
	virtual Size_t getSizeOf() const;
	virtual void show (String&) const;

protected :
	const mdl :: proof :: Scope* const scope_;
};

}
}
}
}

#endif /*MDL_FORM_PROOF_SCOPE_SCOPE_HPP_*/
