/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_interface_block_Assertion.hpp                        */
/* Description:     assertion abstract interface                             */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_BLOCK_ASSERTION_HPP_
#define MDL_INTERFACE_BLOCK_ASSERTION_HPP_

#include "mdl/interface/object/mdl_interface_object.hpp"

namespace mdl {
namespace interface {
namespace block {

class Assertion : virtual public object :: Identifiable {
public :
	virtual value :: Kind getKind() const = 0;
	virtual index :: Assertion getIndex() const = 0;

	// general interface part
	virtual const Variables* getVariables() const = 0;
	virtual const Disjointeds* getDisjointeds() const = 0;

	virtual index :: Arity getHypArity() const = 0;
	virtual index :: Arity getPropArity() const = 0;

	virtual const Hypothesis* getHypothesis (const index :: Arity) const = 0;
	virtual const Proposition* getProposition (const index :: Arity) const = 0;

	// prover specific interface part
	virtual void completeWithHypotheses (mdl :: prover :: tree :: Premise*) const = 0;
};

}
}
}

#endif /*MDL_INTERFACE_BLOCK_ASSERTION_HPP_*/
