/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_interface_block_Proof.hpp                            */
/* Description:     proof abstract interface                                 */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_BLOCK_PROOF_HPP_
#define MDL_INTERFACE_BLOCK_PROOF_HPP_

#include "mdl/interface/object/mdl_interface_object.hpp"

namespace mdl {
namespace interface {
namespace block {

class Proof :
	public object :: Verifiable,
	public object :: Scoping {
public :
	virtual bool isCompressed() const = 0;
	virtual index :: Step getLength() const = 0;
	virtual const proof :: Step* getStep (const index :: Step) const = 0;
	virtual const proof :: Line* getFirst() const = 0;
	virtual const proof :: Line* getLast() const = 0;
	virtual void addStep (const proof :: Step*) = 0;
	virtual void addVariable (const proof :: Variable*) = 0;
	virtual void addQed (const proof :: Qed*) = 0;
};

}
}
}

#endif /*MDL_INTERFACE_BLOCK_PROOF_HPP_*/
