/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_interface_block_Type.hpp                             */
/* Description:     type abstract interface                                  */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_BLOCK_TYPE_HPP_
#define MDL_INTERFACE_BLOCK_TYPE_HPP_

#include "mdl/interface/object/mdl_interface_object.hpp"
#include "mdl/expression/mdl_expression.hpp"

namespace mdl {
namespace interface {
namespace block {

class Type : public object :: Identifiable {
public :
	virtual const tree :: Rule* getRuleTree() const = 0;
	virtual void addRule (const Rule* const) = 0;

	virtual bool isSuper (const Type* const) const = 0;
	virtual bool isInfer (const Type* const) const = 0;

	virtual index :: Type getSuperCount() const = 0;
	virtual const Super* getSuper (const index :: Type) const = 0;
	virtual const Super* getSuper (const Type* const) const = 0;

	virtual index :: Type getSubtypeCount() const = 0;
	virtual const Type* getSubtype (const index :: Type) const = 0;
	virtual void addSubtype (const Type*) = 0;
};

}
}
}

#endif /*MDL_INTERFACE_BLOCK_TYPE_HPP_*/
