/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_interface_header_statement_Proposition.hpp           */
/* Description:     abstract interface for proposition statement             */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_HEADER_STATEMENT_PROPOSITION_HPP_
#define MDL_INTERFACE_HEADER_STATEMENT_PROPOSITION_HPP_

#include "mdl/interface/header/statement/mdl_interface_header_statement_Statement.hpp"

namespace mdl {
namespace interface {
namespace header {
namespace statement {

class Proposition : virtual public Statement {
public :
	virtual index :: Assertion getSourceIndex() const = 0;
	virtual index :: Assertion getTargetIndex() const = 0;
	virtual prover :: Experience& getExperience() const = 0;
};

}
}
}
}

#endif /*MDL_INTERFACE_HEADER_STATEMENT_PROPOSITION_HPP_*/
