/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_interface.hpp                                        */
/* Description:     module for mdl abstract interfaces                       */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_HPP_
#define MDL_INTERFACE_HPP_

#include "mdl/interface/block/mdl_interface_block.hpp"
#include "mdl/interface/header/mdl_interface_header.hpp"
#include "mdl/interface/object/mdl_interface_object.hpp"
#include "mdl/interface/proof/mdl_interface_proof.hpp"
#include "mdl/interface/prover/mdl_interface_prover.hpp"

#include "mdl/interface/mdl_interface_Comments.hpp"
#include "mdl/interface/mdl_interface_Contents.hpp"
#include "mdl/interface/mdl_interface_Identificator.hpp"
#include "mdl/interface/mdl_interface_Import.hpp"
#include "mdl/interface/mdl_interface_Source.hpp"
#include "mdl/interface/mdl_interface_Theory.hpp"

#endif /*MDL_INTERFACE_HPP_*/
