/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_interface_object_Object.cpp                          */
/* Description:     objects                                                  */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_OBJECT_OBJECT_CPP_
#define MDL_INTERFACE_OBJECT_OBJECT_CPP_

#include "mdl/interface/object/mdl_interface_object_Object.hpp"

namespace mdl {
namespace interface {
namespace object {

	/****************************
	 *		Public members
	 ****************************/

	inline void
	Object :: release()
	{
		nstd :: Object :: release();
		if (string_ != NULL) {
			delete string_;
			string_ = NULL;
		}
	}

	// nstd :: Object implementation
	Size_t
	Object :: getVolume() const
	{
		if (nstd :: Object :: volumeCounted_) {
			return 0;
		}
		Size_t volume = 0;
		volume += getAggregateVolume (string_);
		volume += nstd :: Object :: getVolume();
		return volume;
	}
	Size_t
	Object :: getSizeOf() const {
		return sizeof (Object);
	}
	void
	Object :: show (nstd :: String<>& string) const
	{
		if (string_ == NULL) {
			string_ = new String (INITAIL_STRING_CAPACITY);
		} else {
			string_->clear();
		}
		show (*string_);
		string << *string_;
	}

	/****************************
	 *		Operators
	 ****************************/

	String&
	operator << (String& string,  const Object& object)
	{
		object.show (string);
		return string;
	}
	std :: ostream&
	operator << (std :: ostream& os,  const Object& object)
	{
		if (Object :: string_ == NULL) {
			Object :: string_ = new String (Object :: INITAIL_STRING_CAPACITY);
		} else {
			Object :: string_->clear();
		}
		object.show (*(Object :: string_));
		os << *(Object :: string_);
		return os;
	}

	/*************************************
	 *		Private static attributes
	 *************************************/

	String*
		Object :: string_ = NULL;
}
}
}

#endif /*MDL_INTERFACE_OBJECT_OBJECT_CPP_*/
