/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_interface_object_Writable.hpp                        */
/* Description:     abstract interface for writable objects                  */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_OBJECT_WRITABLE_HPP_
#define MDL_INTERFACE_OBJECT_WRITABLE_HPP_

#include "mdl/interface/object/mdl_interface_object_Object.hpp"
#include "mdl/auxiliary/mdl_auxiliary.dpp"

namespace mdl {
namespace interface {
namespace object {

class Writable : virtual public Object {
public :
	virtual void translate (String&) const = 0;
	virtual void replicate (String&) const = 0;

	virtual void show (String&) const;
	virtual void write (Output&) const;
	virtual void write() const;
};

}
}
}

#endif /*MDL_INTERFACE_OBJECT_WRITABLE_HPP_*/
