/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_interface_proof_Reference.hpp                        */
/* Description:     abstract interface for reference to the proof tree node  */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_PROOF_REFERENCE_HPP_
#define MDL_INTERFACE_PROOF_REFERENCE_HPP_

#include "mdl/interface/object/mdl_interface_object.hpp"

namespace mdl {
namespace interface {
namespace proof {

class Reference : virtual public object :: Writable {
public :
	virtual const Node* getNode() const = 0;
	virtual void build (const Scope* const) = 0;
};

}
}
}

#endif /*MDL_INTERFACE_PROOF_REFERENCE_HPP_*/

