/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_interface_proof_Step.hpp                             */
/* Description:     abstract interface for proof step                        */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_PROOF_STEP_HPP_
#define MDL_INTERFACE_PROOF_STEP_HPP_

#include "mdl/interface/proof/mdl_interface_proof_Node.hpp"
#include "mdl/interface/proof/mdl_interface_proof_Line.hpp"

namespace mdl {
namespace interface {
namespace proof {

class Step : virtual public Node, virtual public Line {
public :
	enum Class {
		CLAIM     = Token :: CLAIM,
		QUESTION  = Token :: QUESTION,
		ASSERTION = Token :: THEOREM
	};
	virtual Class getClass() const = 0;
	virtual const Question* questionSelf() const = 0;
	virtual void addReference (const Reference* const) = 0;
	virtual const Location& getLocation() const = 0;
};

}
}
}

#endif /*MDL_INTERFACE_PROOF_STEP_HPP_*/
