/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_interface_prover.hpp                                 */
/* Description:     module for abstract interfaces for proof tree classes    */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_PROVER_HPP_
#define MDL_INTERFACE_PROVER_HPP_

#include "mdl/interface/prover/mdl_interface_prover_Confirmation.hpp"
#include "mdl/interface/prover/mdl_interface_prover_DotEvidence.hpp"
#include "mdl/interface/prover/mdl_interface_prover_Evidence.hpp"
#include "mdl/interface/prover/mdl_interface_prover_Experience.hpp"
#include "mdl/interface/prover/mdl_interface_prover_Level.hpp"
#include "mdl/interface/prover/mdl_interface_prover_Node.hpp"
#include "mdl/interface/prover/mdl_interface_prover_Proof.hpp"
#include "mdl/interface/prover/mdl_interface_prover_Statistics.hpp"

#include "mdl/interface/prover/mdl_interface_prover_DotEvidence.ipp"

#endif /*MDL_INTERFACE_PROVER_HPP_*/
