/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_interface_prover_Expirience.hpp                      */
/* Description:     abstract interface for expirience in proofs              */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_PROVER_EXPERIENCE_HPP_
#define MDL_INTERFACE_PROVER_EXPERIENCE_HPP_

#include "mdl/interface/object/mdl_interface_object.hpp"

namespace mdl {
namespace interface {
namespace prover {

class Experience : public object :: Object {
public :
	virtual void addPositive (const proof :: Step* const) = 0;
	virtual void addNegative (const proof :: Step* const) = 0;
	virtual value :: Weight evaluateFitness (const index :: Step) const = 0;
};

}
}
}


#endif /*MDL_INTERFACE_PROVER_EXPERIENCE_HPP_*/
