/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_prover_interface_Proof.hpp                           */
/* Description:     interface for proof in prover                            */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_INTERFACE_PROVER_PROOF_HPP_
#define MDL_INTERFACE_PROVER_PROOF_HPP_

#include "mdl/interface/mdl_interface.dpp"

namespace mdl {
namespace interface {
namespace prover {

class Proof : public object :: Object {
public :
	virtual bool isValid() const = 0;
	virtual void verifyIntegrity() const = 0;
	virtual const Evidence* getEvidence() const = 0;
	virtual index :: Step getDepth() const = 0;
	virtual value :: Integer getCardinality() const = 0;
	virtual const mdl :: proof :: Step* compileStep (mdl :: proof :: Step* const) const = 0;
	virtual void compileClaim (mdl :: proof :: Claim* const) const = 0;
	virtual const mdl :: proof :: Reference* getReference() const = 0;
	virtual const mdl :: proof :: Step* getStep() const = 0;
};

}
}
}

#endif /*MDL_INTERFACE_PROVER_PROOF_HPP_*/
