/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_math_Constants.hpp                                   */
/* Description:     global container for constants                           */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_MATH_CONSTANTS_HPP_
#define MDL_MATH_CONSTANTS_HPP_

#include "mdl/interface/mdl_interface.hpp"
#include "mdl/math/mdl_math_Container.hpp"

namespace mdl {
namespace math {

class Constants :
	public Container<mdl :: Constant, index :: Constant>,
	public Scalar<Constants> {
public :
	Constants ();
	virtual ~ Constants();
	
	const mdl :: Constant* get (const index :: Constant) const;
	index :: Constant add (const mdl :: Constant* const);
	bool contain (const value :: Literal);

	// object :: Object interface
	virtual void commitSuicide();
	virtual Size_t getVolume() const;
	virtual Size_t getSizeOf() const;
	virtual void show (String&) const;

private :
	typedef 
		Container<mdl :: Constant, index :: Constant>
		Ancestor_;

	set :: value :: Literal constantSet_;

	enum { 
			INITIAL_CONSTANT_VECTOR_CAPACITY = 1024 
	};
};

}
}

#include "mdl/math/mdl_math_Constants.ipp"

#endif /*MDL_MATH_CONSTANTS_HPP_*/
