/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_math_Constants.ipp                                   */
/* Description:     global container for constants                           */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_MATH_CONSTANTS_IPP_
#define MDL_MATH_CONSTANTS_IPP_

namespace mdl {
namespace math {

	/****************************
	 *		Public members
	 ****************************/

	inline const mdl :: Constant*
	Constants :: get (const index :: Constant index) const {
		return Ancestor_ :: getForm (index);
	}
	inline bool
	Constants :: contain (const value :: Literal literal) {
		const index :: Constant
			index = constantSet_.find (literal);
		return (index != index :: undefined :: CONSTANT);
	}
}
}

#endif /*MDL_MATH_CONSTANTS_IPP_*/
