/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_math_Math.ipp                                        */
/* Description:     all global containers for mdl language                   */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_MATH_MATH_IPP_
#define MDL_MATH_MATH_IPP_

namespace mdl {
namespace math {

	inline Assertions* 
	Math :: assertions() {
		return assertions_;
	}
	inline Constants* 
	Math :: constants() {
		return constants_;
	}
	inline Defiendums*
	Math :: defiendums() {
		return defiendums_;
	}
	inline Rules* 
	Math :: rules() {
		return rules_;
	}
	inline Theories* 
	Math :: theories () {
		return theories_;
	}
	inline Types* 
	Math :: types() {
		return types_;
	}
}
}

#endif /*MDL_MATH_MATH_IPP_*/
