/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_math_Rules.ipp                                       */
/* Description:     global container for syntactic grammar rules             */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_MATH_RULES_IPP_
#define MDL_MATH_RULES_IPP_

namespace mdl {
namespace math {

	/****************************
	 *		Public members
	 ****************************/

	inline const mdl :: Rule*
	Rules :: get (const index :: Rule index) const {
		return Ancestor_ :: getForm (index);
	}
	inline index :: Rule
	Rules :: add (const mdl :: Rule* const rule) {
		return Ancestor_ :: addForm (rule);
	}
}
}

#endif /*MDL_MATH_RULES_IPP_*/
