/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_math_Theories.hpp                                    */
/* Description:     global container for theories                            */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_MATH_THEORIES_HPP_
#define MDL_MATH_THEORIES_HPP_

#include "mdl/interface/mdl_interface.hpp"
#include "mdl/math/mdl_math_Container.hpp"

namespace mdl {
namespace math {

class Theories :
	public Container<mdl :: Theory, index :: Theory>,
	public Scalar<Theories> {
public :
	Theories ();
	virtual ~ Theories();
	
	const mdl :: Theory* get (const index :: Theory) const;
	index :: Theory add (const mdl :: Theory* const);
	mdl :: Theory* getRoot();
	const mdl :: Theory* getRoot() const;
	
	// object :: Object interface
	virtual void commitSuicide();
	virtual Size_t getVolume() const;
	virtual Size_t getSizeOf() const;
	virtual void show (String&) const;

private :
	typedef 
		Container<mdl :: Theory, index :: Theory>
		Ancestor_;

	mdl :: Theory* root_;
	enum { 
		INITIAL_THEORY_VECTOR_CAPACITY = nstd :: KILOBYTE
	};
};

}
}

#include "mdl/math/mdl_math_Theories.ipp"

#endif /*MDL_MATH_THEORIES_HPP_*/
