/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_math_Theories.ipp                                    */
/* Description:     global container for theories                            */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_MATH_THEORIES_IPP_
#define MDL_MATH_THEORIES_IPP_

namespace mdl {
namespace math {

	/****************************
	 *		Public members
	 ****************************/

	inline const mdl :: Theory*
	Theories :: get (const index :: Theory index) const {
		return Ancestor_ :: getForm (index);
	}
	inline index :: Theory
	Theories :: add (const mdl :: Theory* const theory) {
		return Ancestor_ :: addForm (theory);
	}
	inline const mdl :: Theory*
	Theories :: getRoot () const {
		return root_;
	}
	inline mdl :: Theory*
	Theories :: getRoot () {
		return root_;
	}
}
}

#endif /*MDL_MATH_THEORIES_IPP_*/
