/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_math_Types.cpp                                       */
/* Description:     global container for types                               */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_MATH_TYPES_CPP_
#define MDL_MATH_TYPES_CPP_

#include "mdl/math/mdl_math_Types.hpp"

namespace mdl {
namespace math {

	/****************************
	 *		Public members
	 ****************************/

	inline
	Types :: Types () :
	Ancestor_ (INITIAL_TYPE_VECTOR_CAPACITY) {
	}
	Types :: ~ Types() {
	}

using manipulator :: endLine;
using manipulator :: tab;
using manipulator :: space;

	// object :: Object implementation
	void
	Types :: commitSuicide() {
		delete this;
	}
	Size_t
	Types :: getVolume() const  {
		return Ancestor_ :: getVolume();
	}
	Size_t
	Types :: getSizeOf() const {
		return sizeof (Types);
	}
	void
	Types :: show (String& string) const {
		string << tab << "types:       " << tab;
		Ancestor_ :: show (string);
	}
}
}

#endif /*MDL_MATH_TYPES_CPP_*/
