/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_math_Types.hpp                                       */
/* Description:     global container for types                               */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_MATH_TYPES_HPP_
#define MDL_MATH_TYPES_HPP_

#include "mdl/interface/mdl_interface.hpp"
#include "mdl/math/mdl_math_Container.hpp"

namespace mdl {
namespace math {

class Types :
	public Container<mdl :: Type, index :: Type>,
	public Scalar<Types> {
public :
	Types ();
	virtual ~ Types();
	
	const mdl :: Type* get (const index :: Type) const;
	index :: Type add (const mdl :: Type* const);

	// object :: Object interface
	virtual void commitSuicide();
	virtual Size_t getVolume() const;
	virtual Size_t getSizeOf() const;
	virtual void show (String&) const;

private :
	typedef 
		Container<mdl :: Type, index :: Type>
		Ancestor_;
	enum { 
		INITIAL_TYPE_VECTOR_CAPACITY = nstd :: KILOBYTE
	};
};

}
}

#include "mdl/math/mdl_math_Types.ipp"

#endif /*MDL_MATH_TYPES_HPP_*/
