/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_math_Types.ipp                                       */
/* Description:     global container for types                               */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_MATH_TYPES_IPP_
#define MDL_MATH_TYPES_IPP_

namespace mdl {
namespace math {

	/****************************
	 *		Public members
	 ****************************/

	inline const mdl :: Type*
	Types :: get (const index :: Type index) const {
		return Ancestor_ :: getForm (index);
	}
	inline index :: Type
	Types :: add (const mdl :: Type* const type) {
		return Ancestor_ :: addForm (type);
	}
}
}

#endif /*MDL_MATH_TYPES_IPP_*/
