/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_parser_header_Variable.ipp                           */
/* Description:     variable declaration parser                              */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_PARSER_HEADER_VARIABLE_IPP_
#define MDL_PARSER_HEADER_VARIABLE_IPP_

namespace mdl {
namespace parser {
namespace header {

	/****************************
	 *		Public members
	 ****************************/

	template<class I>
	const mdl :: header :: Variable*
	Variable :: parse (Lexer* lexer)
	{
		typedef I Implementation;
		location_ = lexer->getLocation();
		literal_ = lexer->scanLiteralName();
		lexer->scan <Token :: COLON>();
		type_ = identificatorParser_->parse (lexer);
		return new Implementation (location_, literal_, type_);
	}
}
}
}

#endif /*MDL_PARSER_HEADER_VARIABLES_IPP_*/
