/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_parser.cpp                                           */
/* Description:     mdl AST parser module                                    */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_PARSER_CPP_
#define MDL_PARSER_CPP_

#include "mdl/parser/block/mdl_parser_block.cpp"
#include "mdl/parser/header/mdl_parser_header.cpp"
#include "mdl/parser/proof/mdl_parser_proof.cpp"

#include "mdl/parser/mdl_parser_Contents.cpp"
#include "mdl/parser/mdl_parser_Expression.cpp"
#include "mdl/parser/mdl_parser_Identificator.cpp"
#include "mdl/parser/mdl_parser_Import.cpp"
#include "mdl/parser/mdl_parser_Source.cpp"
#include "mdl/parser/mdl_parser_Theory.cpp"

#endif /*MDL_PARSER_CPP_*/
