/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_parser.hpp                                           */
/* Description:     mdl AST parser module                                    */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_PARSER_HPP_
#define MDL_PARSER_HPP_

#include "mdl/parser/block/mdl_parser_block.hpp"
#include "mdl/parser/header/mdl_parser_header.hpp"
#include "mdl/parser/proof/mdl_parser_proof.hpp"

#include "mdl/parser/mdl_parser_Contents.hpp"
#include "mdl/parser/mdl_parser_Expression.hpp"
#include "mdl/parser/mdl_parser_Identificator.hpp"
#include "mdl/parser/mdl_parser_Import.hpp"
#include "mdl/parser/mdl_parser_Source.hpp"
#include "mdl/parser/mdl_parser_Theory.hpp"

#endif /*MDL_PARSER_HPP_*/
