/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_prover_evidence_Prop_Multyindex.hpp                  */
/* Description:     vector of indexes for proofs                             */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_PROVER_EVIDENCE_PROP_MULTYINDEX_HPP_
#define MDL_PROVER_EVIDENCE_PROP_MULTYINDEX_HPP_

#include "mdl/prover/mdl_prover.dpp"

namespace mdl {
namespace prover {
namespace evidence {

class Prop :: Multyindex {
public :
	Multyindex
	(
		const index :: Arity,
		const vector :: Proof*
	);

	const Proof* getValue (const index :: Arity) const;
	bool operator ++();
	value :: Integer getVolume() const;

	template<class S>
	void show (S&) const;

private :
	typedef
		mdl :: vector :: Vector
		<
			value :: Integer,
			storage :: ByValue,
			allocator :: Stack
		>
		IndexVector_;

	bool increment (const index :: Arity = 0);

	const index :: Arity   dimension_;
	const vector :: Proof* matrix_;
	IndexVector_           indexVector_;
};

	template<class S>
	S&
	operator << (S&, const Prop :: Multyindex&);
	std :: ostream&
	operator << (std :: ostream&, const Prop :: Multyindex&);
}
}
}

#endif /*MDL_PROVER_EVIDENCE_PROP_MULTYINDEX_HPP_*/
