/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_prover_Timers.hpp                                    */
/* Description:     timers for prover class                                  */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_PROVER_TIMERS_HPP_
#define MDL_PROVER_TIMERS_HPP_

#include "mdl/types/mdl_types.hpp"

namespace mdl {
namespace prover {

class Timers {
public :
	Timers();

	bool refresh();
	void start();
	void mark();
	void stop();
	void recount();

	Clock_t limit() const;
	Timer prove() const;
	Timer refresh() const;
	void setLimit (const Clock_t);

	Size_t getVolume() const;
	Size_t getSizeOf() const;
	void show (String&) const;

private :
	Clock_t limitPrime_;
	Clock_t limitSecond_;
	Timer prove_;
	Timer refresh_;
	bool  recounted_;
};

	String&
	operator << (String&, const Timers&);
}
}

#endif /*MDL_PROVER_TIMERS_HPP_*/
