/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_prover_node_Prop_Prod.hpp                            */
/* Description:     decart product matrix unification                        */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_PROVER_NODE_PROP_PROD_HPP_
#define MDL_PROVER_NODE_PROP_PROD_HPP_

#include "mdl/prover/mdl_prover.dpp"

namespace mdl {
namespace prover {
namespace node {

class Prop :: Prod {
public :
	static value :: Integer getMatrixSearchVolume (const Prop*);
	static void unify (const Prop*, evidence :: Vector&);

private :
	static void fillMatrix
	(
		const Prop*,
		const index :: Arity,
		proof :: Matrix&
	);
	static void addEvidence (const Prop*, evidence :: Vector&);
};

}
}
}

#endif /*MDL_PROVER_NODE_PROP_PROD_HPP_*/
