/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_prover_node_Prop_Tree.hpp                            */
/* Description:     matrix tree unification                                  */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_PROVER_NODE_PROP_TREE_HPP_
#define MDL_PROVER_NODE_PROP_TREE_HPP_

#include "mdl/prover/mdl_prover.dpp"

namespace mdl {
namespace prover {
namespace node {

class Prop :: Tree {
public :
	static void unify (const Prop*, evidence :: Vector&);

private :
	static void unifyTrivialMatrix (const Prop*, evidence :: Vector&, const index :: Arity);
	static void createVariables (const Prop*, vector :: Symbol&);
	static bool createMatrix (const Prop*, const vector :: Symbol&, matrix :: Cell&);
	static value :: Integer calculateBoundary (const Prop*, const vector :: Symbol&);
	static bool fillCell
	(
		const Prop*,
		const index :: Arity i, // variable (column)
		const index :: Arity j, // hyp (row)
		const Symbol& variable, Cell* cell
	);
	static void showMatrix (const vector :: Symbol&, const matrix :: Cell&);
};

}
}
}

#endif /*MDL_PROVER_NODE_PROP_TREE_HPP_*/
