/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_types.hpp                                            */
/* Description:     module for basic types                                   */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_TYPES_HPP_
#define MDL_TYPES_HPP_

#include <nsgl>

namespace mdl {
namespace type {
	using nstd :: type :: Alternator;
	using nstd :: type :: Equality;
	using nstd :: type :: Empty;
	using nstd :: type :: Selector;
	using nstd :: type :: Switch;
	using nstd :: type :: traits :: Type;
}
namespace memory {
	using nstd :: memory :: UsageMessage;
}
namespace system {
	using namespace nstd :: system;
}
	using nstd :: Counter;
	using nstd :: NameTable;
	using nstd :: OutputFileStream;
	using nstd :: Ptrdiff_t;
	using nstd :: Size_t;
	using nstd :: Time_t;
	using nstd :: Clock_t;
	using nstd :: Undefined;
}
	using nstd :: MemoryUnit;

#include "mdl/types/allocator/mdl_types_allocator.hpp"
#include "mdl/types/array/mdl_types_array.hpp"
#include "mdl/types/chars/mdl_types_chars.hpp"
#include "mdl/types/exception/mdl_types_exception.hpp"
#include "mdl/types/index/mdl_types_index.hpp"
#include "mdl/types/lexer/mdl_types_lexer.hpp"
#include "mdl/types/list/mdl_types_list.hpp"
#include "mdl/types/manipulator/mdl_types_manipulator.hpp"
#include "mdl/types/map/mdl_types_map.hpp"
#include "mdl/types/set/mdl_types_set.hpp"
#include "mdl/types/storage/mdl_types_storage.hpp"
#include "mdl/types/value/mdl_types_value.hpp"
#include "mdl/types/vector/mdl_types_vector.hpp"

namespace mdl {

	typedef
		nstd :: String<allocator :: Heap>
		String;
	typedef
		nstd :: Timer<allocator :: Heap>
		Timer;
	typedef
		nstd :: Path<allocator :: Heap>
		Path;
	typedef
		nstd :: memory :: Space
		Memory;
}

#endif /*MDL_TYPES_HPP_*/

