/*****************************************************************************/
/* Project name:    mdl - mathematics development language                   */
/* File Name:       mdl_types_value_undefined.hpp                            */
/* Description:     basic undefined values                                   */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MDL_TYPES_VALUE_UNDEFINED_HPP_
#define MDL_TYPES_VALUE_UNDEFINED_HPP_

namespace mdl {
namespace value {
namespace undefined {

	const Integer
		INTEGER = Undefined<Integer> :: getValue();
	const Integer
		LONG = Undefined<Long> :: getValue();
	const Literal
		LITERAL = Undefined<Literal> :: getValue();
	const Name
		NAME = Undefined<Name> :: getValue();
	const Weight
		WEIGHT = Undefined<Weight> :: getValue();
	const Factor
		FACTOR = Undefined<Factor> :: getValue();
	const Rate
		RATE = Undefined<Rate> :: getValue();
	const Kind
		KIND = Undefined<Kind> :: getValue();
}
}
}

#endif /*MDL_TYPES_VALUE_UNDEFINEDHPP_*/
