/*****************************************************************************/
/* Project name:    mm - decompiler from metamath to mdl                     */
/* File name:       mm_interface_object_Verifiable.hpp                       */
/* Description:     abstract interface for verifiable object                 */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MM_INTERFACE_OBJECT_VERIFIABLE_HPP_
#define MM_INTERFACE_OBJECT_VERIFIABLE_HPP_

#include "interface/object/mm_interface_object_Translatable.hpp"

namespace mm {
namespace interface {
namespace object {

class Verifiable : virtual public Translatable {
public :
	virtual void check() const = 0;
};

}
}
}

#endif /*MM_INTERFACE_OBJECT_VERIFIABLE_HPP_*/
