/*****************************************************************************/
/* Project name:    mm - decompiler from metamath to mdl                     */
/* File name:       mm_parser_block.cpp                                      */
/* Description:     metamath block parser module                             */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MM_PARSER_BLOCK_CPP__
#define MM_PARSER_BLOCK_CPP__

#include "parser/block/mm_parser_block_Assertion.cpp"
#include "parser/block/mm_parser_block_Axiomatic.cpp"
#include "parser/block/mm_parser_block_Constants.cpp"
#include "parser/block/mm_parser_block_Disjoined.cpp"
#include "parser/block/mm_parser_block_Essential.cpp"
#include "parser/block/mm_parser_block_Floating.cpp"
#include "parser/block/mm_parser_block_Proof.cpp"
#include "parser/block/mm_parser_block_Provable.cpp"
#include "parser/block/mm_parser_block_Reference.cpp"
#include "parser/block/mm_parser_block_Variables.cpp"

#endif /* MM_PARSER_BLOCK_CPP__ */
