/*****************************************************************************/
/* Project name:    mm - decompiler from metamath to mdl                     */
/* File name:       mm_parser_Include.hpp                                    */
/* Description:     inclusion parser                                         */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef MM_PARSER_INCLUDE_HPP_
#define MM_PARSER_INCLUDE_HPP_

#include "interface/mm_interface.hpp"
#include "parser/mm_parser.dpp"
#include "lexer/mm_lexer.hpp"

namespace mm {
namespace parser {

class Include :
	public object :: Object,
	public Scalar<Include> {
public :
	Include();
	virtual ~ Include();

	const mm :: source :: Include* parse (Lexer* const);

	// object :: Object interface
	virtual void commitSuicide();
	virtual Size_t getVolume() const;
	virtual Size_t getSizeOf() const;
	virtual void show (String&) const;

private :
	String path_;
	Location location_;
	enum {
		INITIAL_PATH_CAPACITY = 64
	};
};

}
}

#endif /*MM_PARSER_INCLUDE_HPP_*/
