/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_config_Base.cpp                                     */
/* Description:     base config class                                        */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_CONFIG_BASE_CPP_
#define NSGL_CONFIG_BASE_CPP_

#include "config/nsgl_config_Base.hpp"

namespace nstd {
namespace config {

	/****************************
	 *		Public members
	 ****************************/

	bool
	Base :: abortParsing() {
		return abortParsing_;
	}

	/****************************
	 *		Protected members
	 ****************************/

	Size_t
	Base :: getVolume() {
		return 0;
	}
	Size_t
	Base :: stringLength (const char string[])
	{
		Size_t length = 0;
		while (string [length] != '\0') {
			length ++;
		}
		return length;
	}

	bool
	Base :: equalStrings (const char* str_1,  const char* str_2)
	{
		while (*str_2 != 0) {
			if (*str_1 != *str_2) {
				return false;
			}
			str_1 ++;
			str_2 ++;
		}
		return (*str_1 == 0);
	}

	void
	Base :: copyString (const char* const str_1, char* const str_2)
	{
		const Size_t
			length_1 = stringLength (str_1);

		const Size_t
			length_2 = stringLength (str_2);

		for (Size_t i = 0; i < length_1; i ++) {
			str_2 [i] = str_1 [i];
		}
		for (Size_t i = length_1; i < length_2; i++) {
			str_2 [i] = '\0';
		}
	}

	/************************************
	 *		Static private attributes
	 ************************************/

	bool Base :: abortParsing_ = false;
}
}

#endif /*NSGL_CONFIG_BASE_CPP_*/
