/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_config_Base.hpp                                     */
/* Description:     base config class                                        */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_CONFIG_BASE_HPP_
#define NSGL_CONFIG_BASE_HPP_

#include <nstl.hpp>
#include "config/nsgl_config.dpp"

namespace nstd {
namespace config {

class Base {
public :
	static bool abortParsing();

protected :
	static Size_t getVolume();

	/// Checks iff two strings are equal.
	static bool equalStrings (const char*, const char*);
	/// Returns the length of a string.
	static Size_t stringLength (const char string[]);
	/// Copies first argument to the second argument.
	static void copyString (const char* const, char* const);

	/// Do not parse file.
	static bool abortParsing_;
};

}
}

#endif /*NSGL_CONFIG_BASE_HPP_*/
