/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_config_Config.hpp                                   */
/* Description:     resulting config class                                   */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_CONFIG_CONFIG_HPP_
#define NSGL_CONFIG_CONFIG_HPP_

#include "config/nsgl_config_General.hpp"
#include "config/nsgl_config_Paths.hpp"
#include "config/nsgl_config_Program.hpp"
#include "config/nsgl_config_Memory.hpp"

namespace nstd {
namespace config {

class Config :
	public General,
	public Paths,
	public Program,
	public Memory {
protected :
	/// Shows the options usage message.
	static void showOptions();
	static void init();
	static void release();
	static Size_t getVolume();

	static bool proceedStringOption (const char*, const int, const char* [], int&);
	static bool proceedOneCharOption (const char*, const int, const char* [], int&);
};

}
}

#endif /*NSGL_CONFIG_CONFIG_HPP_*/
