/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_config_Memory.hpp                                   */
/* Description:     memory management config flags                           */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_CONFIG_MEMORY_HPP_
#define NSGL_CONFIG_MEMORY_HPP_

#include "config/nsgl_config_Base.hpp"

namespace nstd {
namespace config {

class Memory : public Base {
public :
	static bool showMemory();
	static bool showMemoryUsage();
	static bool showMemoryAlloc();
	static bool showMemoryBalance();
	static bool showMemoryDisposed();
	static bool showMemoryDetails();
	static bool showMemoryFragmentation();

protected :
	// Shows the usage message.
	static void showOptions();
	static void init();
	static void release();
	static Size_t getVolume();

	static bool proceedStringOption (const char*);
	static bool proceedOneCharOption (const char*);

private :
	static bool showMemoryUsage_;
	static bool showMemoryAlloc_;
	static bool showMemoryBalance_;
	static bool showMemoryDisposed_;
	static bool showMemoryDetails_;
	static bool showMemoryFragmentation_;
};

}
}

#endif /*NSGL_CONFIG_MEMORY_HPP_*/
