/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_config_Program.hpp                                  */
/* Description:     program description config flags                         */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_CONFIG_PROGRAM_HPP_
#define NSGL_CONFIG_PROGRAM_HPP_

#include "config/nsgl_config_Base.hpp"

namespace nstd {
namespace config {

class Program : public Base {
public :
	static String<>& version();
	static String<>& programName();
	static String<>& programDescription();
	static const String<>& getVersion();
	static const String<>& getProgramName();
	static const String<>& getProgramDescription();
	static bool showVersion();

protected :
	static void showProgramInfo();
	static void showProgramUsage();
	static void showOptions();
	static void init();
	static void release();
	static Size_t getVolume();

	static bool proceedStringOption (const char*);
	static bool proceedOneCharOption (const char*);

private :
	static String<>* version_;
	static String<>* programName_;
	static String<>* programDescription_;

	static bool showVersion_;

	enum {
		INITIAL_VERSION_CAPACITY = 64,
		INITIAL_PROGRAM_NAME_CAPACITY = 256,
		INITIAL_PROGRAM_DESCRIPTION_CAPACITY = 512
	};
};

}
}

#endif /*NSGL_CONFIG_PROGRAM_HPP_*/
