/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_lexer_Char.cpp                                      */
/* Description:     lexer char wrapper                                       */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_LEXER_CHAR_CPP_
#define NSGL_LEXER_CHAR_CPP_

#include "lexer/nsgl_lexer_Char.hpp"

namespace nstd {
namespace lexer {

	/****************************
	 *		Public members
	 ****************************/

using manipulator :: space;
using manipulator :: tab;
using manipulator :: endLine;

	// nstd :: Object implementation
	Size_t 
	Char :: getVolume() const {
		return 0;
	}
	Size_t 
	Char :: getSizeOf() const {
		return sizeof (Char);
	}
	void 
	Char :: show (String<>& string) const
	{
		string << "char:"  << tab << getValue() << endLine;
		string << "string:" << tab << char_ << endLine;
	}
}
}

#endif /*NSGL_LEXER_CHAR_CPP_*/
