/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_lexer_ExpressionScaner.hpp                          */
/* Description:     template for expression scaners                          */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_LEXER_EXPRESSION_SCANER_HPP_
#define NSGL_LEXER_EXPRESSION_SCANER_HPP_

#include "lexer/nsgl_lexer_Source.hpp"

namespace nstd {
namespace lexer {

// E - expression scaner, T - token type
template<class E, class T>
class ExpressionScaner {
public :
	ExpressionScaner (Source& source) :
	source_ (source) {
	}
	
	typename T :: Type scan ()
	{
		if (E :: isTerminal (source_.getChar())) {
			return T :: UNKNOWN;
		}
		while (!E :: isTerminal (source_.getChar())) {
			++ source_;
		}
		return E :: getTokenType();
	}

private :
	Source& source_;
};

}
}

#endif /*NSGL_LEXER_EXPRESSION_SCANER_HPP_*/
