/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_lexer_Indent.cpp                                    */
/* Description:     indent                                                   */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_LEXER_INDENT_CPP_
#define NSGL_LEXER_INDENT_CPP_

#include "lexer/nsgl_lexer_Indent.hpp"

namespace nstd {
namespace lexer {

	/****************************
	 *		Public members
	 ****************************/

using manipulator :: space;
using manipulator :: tab;
using manipulator :: endLine;

	// nstd :: Object implementation
	void
	Indent :: commitSuicide() {
		delete this;
	}
	Size_t
	Indent :: getVolume() const {
		return 0;
	}
	Size_t
	Indent :: getSizeOf() const {
		return sizeof (Indent);
	}
	void
	Indent :: show (String<>& string) const
	{
		string << "tabs:" << space << tabs_ << "," << space;
		string << "spaces:" << space << spaces_ << "." << endLine;
	}
}
}

#endif /* NSGL_LEXER_INDENT_CPP_ */
