/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_lexer_Indent.hpp                                    */
/* Description:     indent                                                   */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_LEXER_INDENT_HPP_
#define NSGL_LEXER_INDENT_HPP_

#include <nstl.hpp>

namespace nstd {
namespace lexer {

class Indent : public Object {
public :
	typedef U_int16_t Index_;

	Indent();
	Indent (const Indent&);

	bool operator == (const Indent&) const;
	bool operator != (const Indent&) const;
	void operator = (const Indent&);

	void incSpaces();
	void incTabs();
	void newLine();

	void clear();
	template<class A>
	void print (String<A>&) const;

	// nstd :: Object interface
	virtual void commitSuicide();
	virtual Size_t getVolume() const;
	virtual Size_t getSizeOf() const;
	virtual void show (String<>&) const;

private :
	Index_ spaces_;
	Index_ tabs_;
};

	template<class A>
	String<A>&
	operator << (String<A>&, const Indent&);

}
}

#endif /* NSGL_LEXER_INDENT_HPP_ */
