/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_lexer_Location.cpp                                  */
/* Description:     location in input                                        */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_LEXER_LOCATION_CPP_
#define NSGL_LEXER_LOCATION_CPP_

#include "lexer/nsgl_lexer_Source.hpp"
#include "lexer/nsgl_lexer_Location.hpp"

namespace nstd {
namespace lexer {

	/****************************
	 *		Public members
	 ****************************/

	// nstd :: Object implementation
	void
	Location :: commitSuicide() {
		delete this;
	}
	Size_t
	Location :: getVolume() const
	{
		Size_t volume = 0;
		volume += position_.getVolume();
		volume += indent_.getVolume();
		return volume;
	}
	Size_t
	Location :: getSizeOf() const {
		return sizeof (Location);
	}
	void
	Location :: show (String<>& string) const
	{
		//show<String<>&> (string);
		if (source_ != NULL) {
			source_->show (string);
		}
		position_.show (string);
		if (source_ != NULL) {
			//source_->buffer_.rewind (position_);
			//source_->buffer_.show (string);
		}
	}
}
}

#endif /*NSGL_LEXER_LOCATION_CPP_*/
