/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_lexer_Position.cpp                                  */
/* Description:     position in input stream                                 */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_LEXER_POSITION_CPP_
#define NSGL_LEXER_POSITION_CPP_

#include "lexer/nsgl_lexer_Position.hpp"

namespace nstd {
namespace lexer {

	/****************************
	 *		Public members
	 ****************************/

using manipulator :: space;
using manipulator :: tab;
using manipulator :: endLine;

	// nstd :: Object implementation
	void
	Position :: commitSuicide() {
		delete this;
	}
	Size_t
	Position :: getVolume() const {
		return 0;
	}
	Size_t
	Position :: getSizeOf() const {
		return sizeof (Position);
	}
	void
	Position :: show (String<>& string) const
	{
		//show<String<>&> (string);
		if (isUndefined()) {
			return;
		}
		string << "position:" << endLine;
		if (line_ != Undefined<Line_> :: getValue ()) {
			string << tab << "line:" << tab << line_ + 1<< endLine;
		}
		if (column_ != Undefined<Column_> :: getValue()) {
			string << tab << "column:" << tab << column_ + 1<< endLine;
		}
		if (index_ != Undefined<Index_> :: getValue()) {
			//string << tab << "index:" << tab << index_ << endLine;
		}
	}
}
}

#endif /*NSGL_LEXER_POSITION_CPP_*/
