/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_Counter.hpp                                         */
/* Description:     static counter class                                     */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_COUNTER_HPP_
#define NSGL_COUNTER_HPP_

#include <nstl>
#include "nsgl/nsgl.dpp"

namespace nstd {

class Counter {
public :
	typedef Size_t Index_;
	typedef Size_t Count_;

	static void switchOn (const Index_ = 0);
	static void switchOff (const Index_ = 0);
	static bool stop (const Index_ = 0);
	static void set (const Count_ = 0, const Index_ = 0);
	static void coset (const Count_ = 0, const Index_ = 0);
	static void force (const Index_ = 0);
	static void inc (const Index_ = 0);
	static Count_ get (const Index_ = 0);
	static void show (Index_ = 0);

private :
	enum {
		DIMENSION = 32
	};
	static void init();
	static Index_ counter_ [DIMENSION];
	static Index_ stopCount_ [DIMENSION];
	static Index_ startCount_ [DIMENSION];
	static bool isOn_ [DIMENSION];
	static bool initialized_;
};

}

#endif /*NSGL_COUNTER_HPP_*/
