/*****************************************************************************/
/* Project name:    nsgl - non-standard general library                      */
/* File name:       nsgl_system.hpp                                          */
/* Description:     system interface module                                  */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSGL_SYSTEM_HPP_
#define NSGL_SYSTEM_HPP_

#include <nstl.hpp>

namespace nstd {
namespace system {

	Size_t getFileSize (const char* const);
	bool createDirectory (const char* const);
	Time_t getTime();
	Clock_t getClock();
	Clock_t getClocksPerSecond();
	Clock_t getClocksPerMinute();
	Clock_t getClocksPerHour();
}
}

#endif /*NSGL_SYSTEM_HPP_*/
