/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_allocator_Boxed.hpp                          */
/* Description:     allocator to the boxed memory                            */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_ALLOCATOR_BOXED_HPP_
#define NSTL_MEMORY_ALLOCATOR_BOXED_HPP_

#include "memory/nstl_memory_Interval.hpp"
#include "memory/allocator/nstl_memory_allocator_Method.hpp"

namespace nstd {
namespace memory {
namespace allocator {

class Boxed {
public :
	template<class T>
	static const Interval<T> allocate (const Size_t, const Method = DEFAULT);

	template<class T>
	static void dispose (const Interval<T>&);
};

}
}
}

#endif /*NSTL_MEMORY_ALLOCATOR_BOXED_HPP_*/
