/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_allocator_Heap.ipp                           */
/* Description:     heap allocator                                           */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_ALLOCATOR_HEAP_IPP_
#define NSTL_MEMORY_ALLOCATOR_HEAP_IPP_

namespace nstd {
namespace memory {
namespace allocator {

	/****************************
	 *		Public members
	 ****************************/

	template<class T>
	inline const Interval<T>
	Heap :: allocate (const Size_t length, const Method method)
	{
		typedef T Type;
		if (length == 0) {
			return Interval<Type>();
		}
		return Space :: template allocateHeap<Type> (length, method);
	}

	template<class T>
	inline void
	Heap :: dispose (const Interval<T>& interval)
	{
		typedef T Type;
		Space :: template disposeHeap<Type> (interval);
	}
}
}
}

#endif /*NSTL_MEMORY_ALLOCATOR_HEAP_IPP_*/
