/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_allocator_Method.hpp                         */
/* Description:     allocation method                                        */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_ALLOCATOR_METHOD_HPP_
#define NSTL_MEMORY_ALLOCATOR_METHOD_HPP_

namespace nstd {
namespace memory {
namespace allocator {

	/// Allocation methods.
	enum Method {
		EXACT,						///< Exact method. Allocates exact amount of bytes.
		GREEDY,					///< Used for vectors. May allocate more bytes then it was demanded.
		DEFAULT = EXACT	///< Default allocation method.
	};
}
}
}

#endif /*NSTL_MEMORY_ALLOCATOR_METHOD_HPP_*/
