/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_allocator_Stack.ipp                          */
/* Description:     stack allocator                                          */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_ALLOCATOR_STACK_IPP_
#define NSTL_MEMORY_ALLOCATOR_STACK_IPP_

namespace nstd {
namespace memory {
namespace allocator {

	/****************************
	 *		Public members
	 ****************************/

	template<class T>
	inline const Interval<T>
	Stack :: allocate (const Size_t length, const Method)
	{
		typedef T Type;
		if (length == 0) {
			return Interval<Type>();
		}
		return Space :: template allocateStack<Type> (length);
	}

	template<class T>
	inline void
	Stack :: dispose (const Interval<T>&) {
	}
}
}
}

#endif /*NSTL_MEMORY_ALLOCATOR_STACK_IPP_*/

