/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_allocator_Standard.ipp                       */
/* Description:     allocator to the standard heap memory                    */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_ALLOCATOR_STANDARD_IPP_
#define NSTL_MEMORY_ALLOCATOR_STANDARD_IPP_

namespace nstd {
namespace memory {
namespace allocator {

	/****************************
	 *		Public members
	 ****************************/

	template<class T>
	inline const Interval<T>
	Standard :: allocate (const Size_t length, const Method)
	{
		typedef T Type;
		if (length == 0) {
			return Interval<Type>();
		}
		return Space :: template allocateStandard<Type> (length);
	}

	template<class T>
	inline void
	Standard :: dispose (const Interval<T>& interval)
	{
		typedef T Type;
		Space :: template disposeStandard<Type> (interval);
	}
}
}
}

#endif /*NSTL_MEMORY_ALLOCATOR_STANDARD_IPP_*/
