/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_exception_EmptyStackPop.hpp                  */
/* Description:     exception at empty stack pop attempt                     */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_EXCEPTION_EMPTY_STACK_POP_HPP_
#define NSTL_MEMORY_EXCEPTION_EMPTY_STACK_POP_HPP_

#include "memory/exception/nstl_memory_exception_Exception.hpp"

namespace nstd {
namespace memory {
namespace exception {

class EmptyStackPop : public Exception {
public :
	EmptyStackPop() throw();
	EmptyStackPop (const EmptyStackPop&) throw();
	virtual ~ EmptyStackPop() throw();
};

}
}
}

#endif /*NSTL_MEMORY_EXCEPTION_EMPTY_STACK_POP_HPP_*/
