/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_exception_Exception.hpp                      */
/* Description:     base memory exception class                              */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_EXCEPTION_EXCEPTION_HPP_
#define NSTL_MEMORY_EXCEPTION_EXCEPTION_HPP_

#include <ostream>
#include <exception>

namespace nstd {
namespace memory {
namespace exception {

class Exception : public std :: exception {
public :
	Exception (const char* = "memory exception") throw();
	Exception (const Exception&) throw();
	virtual ~ Exception() throw();

	virtual const char* what() const throw();
	virtual const char* getMessage() const throw();

protected :
	const char* message_;
};

	std :: ostream&
	operator << (std :: ostream&, const Exception&);

}
}
}

#endif /*NSTL_MEMORY_EXCEPTION_EXCEPTION_HPP_*/
