/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_exception_OutOfMemory.cpp                    */
/* Description:     out of memory exception                                  */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_EXCEPTION_OUT_OF_MEMORY_CPP_
#define NSTL_MEMORY_EXCEPTION_OUT_OF_MEMORY_CPP_

namespace nstd {
namespace memory {
namespace exception {

	/****************************
	 *		Public members
	 ****************************/

	inline
	OutOfMemory :: OutOfMemory (const Class_ c) throw() :
	Exception ("out of memory"),
	class_ (c) {
	}
	inline
	OutOfMemory :: OutOfMemory (const OutOfMemory& exception) throw() :
	Exception (exception),
	class_ (exception.class_) {
	}
	inline
	OutOfMemory :: ~ OutOfMemory() throw() {
	}
	inline void
	OutOfMemory :: setClass (const Class_ c) throw()
	{
		class_ = c;
		switch (class_) {
			case NONE  : message_ = "out of memory";       break;
			case STACK : message_ = "out of stack memory"; break;
			case HEAP  : message_ = "out of heap memory";  break;
			case BOXED : message_ = "out of boxed memory"; break;
			case STANDARD : message_ = "out of standard heap memory"; break;
			default :    message_ = "out of memory";
		}
	}
	inline OutOfMemory :: Class_
	OutOfMemory :: getClass() const throw() {
		return class_;
	}
}
}
}

#endif /*NSTL_MEMORY_EXCEPTION_OUT_OF_MEMORY_CPP_*/
