/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_exception_OutOfMemory.hpp                    */
/* Description:     out of memory exception                                  */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_EXCEPTION_OUT_OF_MEMORY_HPP_
#define NSTL_MEMORY_EXCEPTION_OUT_OF_MEMORY_HPP_

#include "memory/exception/nstl_memory_exception_Exception.hpp"

namespace nstd {
namespace memory {
namespace exception {

class OutOfMemory : public Exception {
public :
	enum Class_ {
		NONE,
		STACK,
		HEAP,
		BOXED,
		STANDARD
	};
	OutOfMemory (const Class_ = NONE) throw();
	OutOfMemory (const OutOfMemory&) throw();
	virtual ~ OutOfMemory() throw();

	void setClass (const Class_) throw();
	Class_ getClass() const throw();

private :
	Class_ class_;
};

}
}
}

#endif /*NSTL_MEMORY_EXCEPTION_OUT_OF_MEMORY_HPP_*/
