/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_Space.cpp                                    */
/* Description:     general memory space                                     */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_SPACE_CPP_
#define NSTL_MEMORY_SPACE_CPP_

#include <iostream>

namespace nstd {
namespace memory {

	/****************************
	 *		Public members
	 ****************************/

	Size_t
	Space :: getUsedVolume ()
	{
		Size_t volume = 0;
		volume += heap_.getUsedVolume();
		volume += stack_.getUsedVolume();
		volume += boxed_.getUsedVolume();
		volume += standard_.getUsedVolume();
		return volume;
	}
	Size_t
	Space :: getOverallVolume ()
	{
		Size_t volume = 0;
		volume += heap_.getOverallVolume();
		volume += stack_.getOverallVolume();
		volume += boxed_.getOverallVolume();
		volume += standard_.getOverallVolume();
		return volume;
	}
	Size_t
	Space :: getAllocatedVolume ()
	{
		Size_t volume = 0;
		volume += heap_.getAllocatedVolume();
		volume += stack_.getAllocatedVolume();
		volume += boxed_.getAllocatedVolume();
		volume += standard_.getAllocatedVolume();
		return volume;
	}
	Size_t
	Space :: getDisposedVolume ()
	{
		Size_t volume = 0;
		volume += heap_.getDisposedVolume();
		volume += boxed_.getDisposedVolume();
		return volume;
	}
	Size_t
	Space :: getFreeVolume ()
	{
		Size_t volume = 0;
		volume += heap_.getFreeVolume();
		volume += stack_.getFreeVolume();
		volume += boxed_.getFreeVolume();
		return volume;
	}

	/***********************************
	 *		Private static attributes
	 ***********************************/

	unit :: Heap
		Space :: heap_;
	unit :: Stack
		Space :: stack_;
	unit :: Boxed
		Space :: boxed_;
	unit :: Standard
		Space :: standard_;
}
}

#endif /*NSTL_MEMORY_SPACE_CPP_*/
