/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_UsageMessage.hpp                             */
/* Description:     displays memory usage message                            */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_USAGE_MESSAGE_HPP_
#define NSTL_MEMORY_USAGE_MESSAGE_HPP_

#include <ostream>
#include "nstl.tpp"

namespace nstd {
namespace memory {

class UsageMessage {
public :
	enum Unit_ {
		BYTE = nstd :: BYTE,
		KILOBYTE = nstd :: KILOBYTE,
		MEGABYTE = nstd :: MEGABYTE,
		GIGABYTE = nstd :: GIGABYTE,
		AUTO = -1
	};

	UsageMessage (const Size_t, const Size_t, const char[], const Unit_ = AUTO);

	template<class S>
	void show (S&) const;

private :
	const char* unit() const;
	Unit_ calculateUnit (const Size_t) const;

	const Unit_ measureUnit_;
	const Size_t overallVolume_;
	const Size_t currentVolume_;
	const char* const message_;
};

	template<class S>
	S&
	operator << (S&, const UsageMessage&);
}
}

#endif /*NSTL_MEMORY_USAGE_MESSAGE_HPP_*/
