/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_unit_PointerStack.ipp                        */
/* Description:     stack of pointers                                        */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_UNIT_POINTER_STACK_IPP_
#define NSTL_MEMORY_UNIT_POINTER_STACK_IPP_

namespace nstd {
namespace memory {
namespace unit {

	/****************************
	 *		Public members
	 ****************************/

	inline bool
	PointerStack :: isEmpty() const {
		return (topIndex_ == -1);
	}
	inline void
	PointerStack :: clear ()  {
		topIndex_ = -1;
	}
	inline PointerStack :: Index_
	PointerStack :: getMaxDepth() const {
		return maxIndex_ + 1;
	}
	inline PointerStack :: Index_
	PointerStack :: getDepth() const {
		return topIndex_ + 1;
	}

	template<class S>
	void
	PointerStack :: show (S& string) const
	{
		string << "pointer stack:" << chars :: NEW_LINE;
		if (isEmpty()) {
			string << chars :: TAB << "is empty" << chars :: NEW_LINE;
		} else {
			string << chars :: TAB << "current stack depth:" << chars :: SPACE << chars :: TAB;
			string << chars :: TAB << topIndex_ + 1 << chars :: NEW_LINE;
		}
		string << chars :: TAB << "max stack depth:" << chars :: SPACE << chars :: TAB;
		string << chars :: TAB << maxIndex_ + 1 << chars :: NEW_LINE;
		string << chars :: NEW_LINE;
		/*
		const double percentMaxVolume = static_cast<double> (maxSpaceVolume_) * 100 / spaceVolume_;
		string << "max top used: \t\t\t" << maxSpaceVolume_ / 1024 << " kb \t\t";
		string << "(" << maxSpaceVolume_ << ") \t\t";
		string << " = " << percentMaxVolume << " %";
		string << endl;

		const double percentMaxMemUsed = static_cast<double> (maxTotalVolume_) * 100 / spaceVolume_;
		string << "max mem used: \t\t" << maxTotalVolume_ / 1024 << " kb \t\t";
		string << "(" << maxTotalVolume_ << ") \t\t";
		string << " = " << percentMaxMemUsed << " %";
		string << endl;
		*/
	}
}
}
}

#endif /*NSTL_MEMORY_UNIT_POINTER_STACK_IPP_*/
