/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_unit_Stack.cpp                               */
/* Description:     stack memory                                             */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_UNIT_STACK_CPP_
#define NSTL_MEMORY_UNIT_STACK_CPP_

#include "memory/unit/nstl_memory_unit_Stack.hpp"
#include "memory/nstl_memory_UsageMessage.hpp"

namespace nstd {
namespace memory {
namespace unit {

	/****************************
	 *		Public members
	 ****************************/

	inline
	Stack :: Stack () :
	Tank (),
	stack_ (),
	maxVolume_ (0) {
	}

	inline void
	Stack :: create (const Size_t volume) {
		Tank :: create (volume);
	}
	inline void
	Stack :: destroy()
	{
		const Size_t allocated = getAllocatedVolume();
		Tank :: destroy();
		if (allocated != 0) {
			throw exception :: MemoryLeaks (allocated, "stack memory leaks");
		}
	}

	inline Size_t
	Stack :: getUsedVolume() const {
		return 0;
	}
	inline Size_t
	Stack :: getOverallVolume() const {
		return Tank :: getOverallVolume();
	}
	inline Size_t
	Stack :: getAllocatedVolume() const {
		return Tank :: getAllocatedVolume();
	}
	inline Size_t
	Stack :: getFreeVolume() const {
		return Tank :: getFreeVolume();
	}
}
}
}

#endif /*NSTL_MEMORY_UNIT_STACK_CPP_*/
