/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_unit_Stack.hpp                               */
/* Description:     stack memory                                             */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_UNIT_STACK_HPP_
#define NSTL_MEMORY_UNIT_STACK_HPP_

#include "memory/unit/nstl_memory_unit_Tank.hpp"
#include "memory/unit/nstl_memory_unit_PointerStack.hpp"

namespace nstd {
namespace memory {
namespace unit {

class Stack : public Tank {
public :
	typedef PointerStack :: Index_ Index_;

	Stack ();

	void create (const Size_t);
 	void destroy();

	void push();
	void pop();
	void clear();
	bool isEmpty() const;

	Size_t getMaxVolume();
	Index_ getMaxDepth() const;
	Index_ getDepth() const;

	Size_t getUsedVolume() const;
	Size_t getOverallVolume() const;
	Size_t getAllocatedVolume() const;
	Size_t getFreeVolume() const;

	template<class S>
	void show (S&) const;

private :
	friend class memory :: Space;

	template<class T>
	const Interval<T> allocate (const Size_t);

	PointerStack stack_;
	Size_t maxVolume_;
};

}
}
}

#endif /*NSTL_MEMORY_UNIT_STACK_HPP_*/
