/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_memory_unit_Tank.hpp                                */
/* Description:     base class for memory managers                           */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MEMORY_UNIT_TANK_HPP_
#define NSTL_MEMORY_UNIT_TANK_HPP_

#include "memory/nstl_memory_Interval.hpp"

namespace nstd {
namespace memory {
namespace unit {

class Tank {
public :
	Tank();

	void create (const Size_t);
	void clear();
	void destroy();

	bool isRegular() const;
	bool isEmpty() const;
	bool isFull() const;

	template<class T>
	const Interval<T> allocate (const Size_t);

	Size_t getOverallVolume() const;
	Size_t getAllocatedVolume() const;
	Size_t getFreeVolume() const;

	template<class S>
	void show (S&, const char[]) const;

protected :
	const Interval<> space_;
	Interval<> free_;
};

}
}
}

#endif /*NSTL_MEMORY_UNIT_TANK_HPP_*/
