/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl.tpp                                                 */
/* Description:     basic nstl typedefs                                      */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_TPP_
#define NSTL_TPP_

#include <stddef.h>
#include <stdint.h>

#include "nstl_chars.hpp"

namespace nstd {

	typedef :: ptrdiff_t Ptrdiff_t;
	typedef :: size_t    Size_t;
	typedef :: time_t    Time_t;
	typedef :: clock_t   Clock_t;
}

namespace nstd {

	typedef :: uint8_t    Byte_t;
	typedef :: uint8_t    U_int8_t;
	typedef :: uint16_t   U_int16_t;
	typedef :: uint32_t   U_int32_t;
	typedef :: uint64_t   U_int64_t;

	typedef :: int8_t   Int8_t;
	typedef :: int16_t  Int16_t;
	typedef :: int32_t  Int32_t;
	typedef :: int64_t  Int64_t;

	typedef float Float;
	typedef double Double;

	enum MemoryUnit {
		BYTE = 1,
		KILOBYTE = 1024,
		MEGABYTE = KILOBYTE * 1024,
		GIGABYTE = MEGABYTE * 1024
	};
}

#include <fstream>

namespace nstd {

	typedef
		std :: ifstream
		InputFileStream;

	typedef
		std :: ofstream
		OutputFileStream;
}

#endif /*NSTL_TPP_*/
