/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_Object.cpp                                          */
/* Description:     abstract object base class                               */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_OBJECT_CPP_
#define NSTL_OBJECT_CPP_

#include "nstl_Object.hpp"

namespace nstd {

	/****************************
	 *		Public members
	 ****************************/

	inline void
	Object :: release()
	{
		if (string_ != NULL) {
			delete string_;
			string_ = NULL;
		}
	}

	// nstd :: Object implementation
	Size_t
	Object :: getVolume() const
	{
		if (nstd :: Object :: volumeCounted_) {
			return 0;
		}
		volumeCounted_ = true;
		return getAggregateVolume (string_);
	}
	Size_t
	Object :: getSizeOf() const {
		return sizeof (Object);
	}

	/****************************
	 *		Operators
	 ****************************/

	std :: ostream&
	operator << (std :: ostream& os, const Object& object)
	{
		if (Object :: string_ == NULL) {
			Object :: string_ = new String<> (Object :: INITAIL_STRING_CAPACITY);
		} else {
			Object :: string_->clear();
		}
		object.show (*(Object :: string_));
		os << *(Object :: string_);
		return os;
	}

	/***********************************
	 *		Private static attributes
	 ***********************************/

	String<>*
		Object :: string_ = NULL;
	bool
		Object :: volumeCounted_ = false;
}

#endif /*NSTL_OBJECT_CPP_*/
