/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_manipulator.hpp                                     */
/* Description:     nstl string manipulator class                            */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_MANIPULATOR_HPP_
#define NSTL_MANIPULATOR_HPP_

#include "nstl.dpp"

namespace nstd {
namespace manipulator {

	template<class A>
	String<A>& indent (String<A>&);
	template<class A>
	String<A>& identity (String<A>&);
	template<class A>
	String<A>& iterate (String<A>&);
	template<class A>
	String<A>& mode (String<A>&);
	template<class A>
	String<A>& endLine (String<A>&);
	template<class A>
	String<A>& endString (String<A>&);
	template<class A>
	String<A>& space (String<A>&);
	template<class A>
	String<A>& underline (String<A>&);
	template<class A>
	String<A>& tab (String<A>&);
	template<class A>
	String<A>& slash (String<A>&);
	template<class A>
	String<A>& backSlash (String<A>&);
}
}

#endif /*NSTL_MANIPULATOR_HPP_*/
