/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_type_list_Length.hpp                                */
/* Description:     length operation for type list                           */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_TYPE_LIST_LENGTH_HPP_
#define NSTL_TYPE_LIST_LENGTH_HPP_

#include "type/constant/nstl_type_constant.hpp"
#include "type/list/nstl_type_list.dpp"
#include "type/list/nstl_type_list_List.hpp"

namespace nstd {
namespace type {
namespace list {

template<class T>
struct Length {
	typedef 
		typename T :: Tail 
		Tail;
	enum { result = 1 + Length<Tail> :: result };
};

template<>
struct Length<Null> {
	enum { result = 0 };
};

}
}
}

#endif /*NSTL_TYPE_LIST_LENGTH_HPP_*/
