/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_type_Unpointer.hpp                                  */
/* Description:     type unpointer metafunction                              */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_TYPE_UNPOINTER_HPP_
#define NSTL_TYPE_UNPOINTER_HPP_

namespace nstd {
namespace type {

template<class T>
struct Unpointer {
	enum { is_pointer = false };
	typedef T Result_;
};

template<class T>
struct Unpointer<T*> {
	enum { is_pointer = true };
	typedef T Result_;
};

}
}

#endif /*NSTL_TYPE_UNPOINTER_HPP_*/
