/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_type_undefined_Bool.hpp                             */
/* Description:     undefined bool value                                     */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_TYPE_UNDEFINED_BOOL_HPP_
#define NSTL_TYPE_UNDEFINED_BOOL_HPP_

#include "type/traits/nstl_type_traits_Type.hpp"

namespace nstd {
namespace type {
namespace undefined {

template<class T>
class Bool {
};

template<>
class Bool<bool> {
public :
	static const bool getValue () {
		return false;
	}
	static const bool isUndefined (const bool value) {
		return (value == false);
	}
};

}
}
}

#endif /*NSTL_TYPE_UNDEFINED_BOOL_HPP_*/
