/*****************************************************************************/
/* Project name:    nstl - non-standard template library                     */
/* File name:       nstl_type_undefined_Pointer.hpp                          */
/* Description:     undefined pointer value                                  */
/* Copyright:       (c) 2006-2009 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef NSTL_TYPE_UNDEFINED_POINTER_HPP_
#define NSTL_TYPE_UNDEFINED_POINTER_HPP_

#include "nstl.tpp"

#include "type/constant/nstl_type_constant.hpp"
#include "type/traits/nstl_type_traits_Type.hpp"
#include "type/undefined/nstl_type_undefined.dpp"

namespace nstd {
namespace type {
namespace undefined {

template<class T>
class Pointer<T, true> {
public :
	static const T getValue () {
		return NULL;
	}
	
	static const bool isUndefined (const T value) {
		return (value == NULL);
	}
};

template<class T>
class Pointer<T, false> {
};

}
}
}

#endif /*NSTL_TYPE_UNDEFINED_POINTER_HPP_*/
