/*****************************************************************************/
/* Project name:    smm - verifier for the Simplified MetaMath language      */
/* File name:       smm_math_Math.cpp                                        */
/* Description:     static container for global smm structures               */
/* Copyright:       (c) 2006-2010 Dmitri Vlasov                              */
/* Author:          Dmitri Yurievich Vlasov, Novosibirsk, Russia             */
/* Email:           vlasov at academ.org                                     */
/* URL:             http://mathdevlanguage.sourceforge.net                   */
/* Modified by:                                                              */
/* License:         GNU General Public License Version 3                     */
/*****************************************************************************/

#ifndef SMM_MATH_MATH_CPP_
#define SMM_MATH_MATH_CPP_

#include "smm/math/smm_math.hpp"

namespace smm {
namespace math {

	/****************************
	 *		Public members
	 ****************************/

using manipulator :: endLine;

	// nstd :: Static implementation
	void
	Math :: initRaw()
	{
		constants_ = new Constants();
		assertions_ = new Assertions();
	}
	void
	Math :: showRaw (String& string)
	{
		if (isInitialized()) {
			string << "math:" << endLine;
			string << *constants_;
			string << *assertions_;
		}
	}
	Size_t
	Math :: getRawVolume()
	{
		Size_t result = 0;
		result += getAggregateVolume (constants_);
		result += getAggregateVolume (assertions_);
		return result;
	}

	/********************************
	 *		Private static attributes
	 ********************************/

	Assertions*
		Math :: assertions_ = NULL;
	Constants*
		Math :: constants_ = NULL;
}
}

#endif /*SMM_MATH_MATH_CPP_*/

